Subject: Re: libgit2 - a true git library

From: Pierre Habouzit <[email-masked]>
Date: Sat, 01 Nov 2008 02:06:20 +0100

On Sat, Nov 01, 2008 at 12:41:22AM +0000, [email-masked] wrote:
> On Fri, 31 Oct 2008, Shawn O. Pearce wrote:
> 
> >Junio C Hamano <[email-masked]> wrote:
> >>
> >>
> >>I.e. use the supplied custom function to do proprietary magic, such as
> >>reading the object lazily from elsewhere over the network.  And we will
> >>never get that magic bit back.
> >
> >As a maintainer I'd never accept such a patch.  I'd ask for the
> >code under read_object_custom, or toss the patch on the floor.
> >But that doesn't stop them from distributing the patched sources
> >like above, keeping the fun bits in the closed source portion of
> >the executable they distribute.
> >
> >Maybe I just think too highly of the other guy, but I'd hope that
> >anyone patching libgit2 like above would try to avoid it, because
> >they'd face merge issues in the future.
> 
> the issue that I see is that libgit2 will be (on most systems) a shared 
> library.
> 
> what's to stop someone from taking the libgit2 code, adding the magic 
> proprietary piece, and selling a new libgit2 library binary 'just replace 
> your existing shared library with this new one and all your git related 
> programs gain this feature'

Its license. GPL even with GCC exception would not allow you to do that.
Though they could propose a fork of the library patched, with the patch
distributed. The downside would be that their code would not be binary
compatible with the "true" libgit2, so they would probably have to
change the name to avoid namespace clashes, or overwrite the "real"
library.

But yes, it's theoretically feasible. I'm not sure it would be worth the
hassle, and if they respect the license (if they don't they can already
do that with the current git anyway) then the fact that someone would
want to do something like that would be known fact, probably not
avoided, but known.

-- 
·O·  Pierre Habouzit
··O                                                [email-masked]
OOO                                                http://www.madism.org